<?php
/*
This is a class to provide the most commonly used functions
for add/edit/delete table content in the administrations.
*/

class tableEditor
{
	function tableEditor($fields,$table)
	{
		$this->fields=$fields;
		$this->table=$table;	
		
		//enctype for the forms?
		$enctype="";
		
		foreach($this->fields as $field)
		{
			if($field[type]=='file') $enctype="enctype=multipart/form-data";
		}	
	} //end constructor
	
	//to select the values from the table
	function fetch($limit=0,$ob="id",$where_sql="")
	{
		global $offset,$DB;
		
		$q="SELECT * FROM $this->table
		$where_sql
		ORDER BY $ob";
		
		//limit?
		if($limit) $q.=" LIMIT $offset,$limit ";		
		$this->rows=$DB->aq($q);
		
	} //end fetch function
	
	//to display simple add/edit/delete table
	//tree parametter is for often used tree structure - with parent id
	function aed_table($tree=0,$href="")
	{
		//display rows for editing
		
		$cells="<tr>";
		
		if($tree) $cells.="<th width=20>&gt;&gt;</th>";
		
		foreach($this->fields as $field)
		{
			if(empty($field[display])) continue;
			$cells.="<th width=$field[csize]>$field[display]</th>";
		}
		
		$cells.="<th width=100>Action</th></tr>\n";
		
		foreach($this->rows as $row)
		{
			$cells.="<form method=post $enctype>
			<input type=hidden name=id value=$row[id]>
			<input type=hidden name=del value=0>
			<tr>";
			
			if($tree) $cells.="<td><a href=\"$href&parent=$row[id]\">&gt;&gt;</a></td>";
			
			foreach($this->fields as $field)
			{
				if(empty($field[display])) continue;
				$cells.="<td>";
				
				switch($field[type])
				{
					case 'text':
						$cells.="<input type=text name=\"$field[name]\" size='$field[fsize]' value=\"".$row[$field[name]]."\">";
					break;
				}
				
				$cells.="</td>";
			}
			
			$cells.="<td><nobr><input class=button type=submit name=save value=Save>
			<input type=button class=button value=Delete onclick=\"javascript:confirmDelete(this.form);\">
			</nobr></td></tr></form>\n";
		}
		
		//now add "add" row
		$cells.="<form method=post $enctype>			
		<tr>";
		
		if($tree) $cells.="<td>&nbsp;</td>";
			
		foreach($this->fields as $field)
		{
			if(empty($field[display])) continue;
			$cells.="<td>";
				
			switch($field[type])
			{
				case 'text':
					$cells.="<input type=text name=\"$field[name]\" size='$field[fsize]'>";
				break;
			}
				
			$cells.="</td>";
		}
			
		$cells.="<td align=center><input type=submit class=button name=add value=Add></td></tr></form>\n";
		
		return $cells;
		
	} //end aed_table funciton
	
	
	//to display table which lists the rows with an "Edit" button
	//tree parametter is for often used tree structure - with parent id
	function list_table($tree=0,$href="")
	{
		//display rows for editing
		
		$cells="<tr>";
		
		if($tree) $cells.="<th width=20>&gt;&gt;</th>";
		
		foreach($this->fields as $field)
		{
			if(empty($field[display])) continue;
			$cells.="<th width=$field[csize]>$field[display]</th>";
		}
		
		$cells.="<th width=50>Edit</th></tr>\n";
		
		foreach($this->rows as $row)
		{
			$cells.="<tr>";
			
			if($tree) $cells.="<td><a href=\"$href&parent=$row[id]\">&gt;&gt;</a></td>";
			
			foreach($this->fields as $field)
			{
				if(empty($field[display])) continue;
				$cells.="<td>";
				
				switch($field[type])
				{
					case 'date_static':
						$cells.=date_format2($row[$field[name]]);				
					break;
					
					default:
						$cells.=$row[$field[name]];				
					break;
				}
				
				$cells.="</td>";
			}
			
			$cells.="<td><nobr><input class=button type=button value=Edit onclick=\"javascript:window.location='$href&id=$row[id]';\"></nobr></td></tr></form>\n";
		}
		
		return $cells;
		
	} //end list_table funciton
	
	
	//this function display add/edit/delete table for ONE record
	function one_table($id=0,$validate=0, $buttons=TRUE)
	{
		global $DB;
		
		if($id)
		{
			$q="SELECT * FROM $this->table WHERE id='$id'";
			$record=$DB->sq($q);
		}
		
		$trows="";
		
		foreach($this->fields as $field)
		{
			switch($field[type])
			{
				case 'text':
					$trows.="<tr><td>$field[display]:</td>
					<td><input type=text name=\"$field[name]\" value=\"".$record[$field[name]]."\" size='$field[fsize]'></td></tr>\n";
				break;
				
				case 'pass':
					$trows.="<tr><td>$field[display]:</td>
					<td><input type=password name=\"$field[name]\" size='$field[fsize]'></td></tr>\n
					<tr><td>Confirm $field[display]:</td>
					<td><input type=password name=\"re$field[name]\" size='$field[fsize]'></td></tr>\n";
				break;
				
				case 'checkbox':
					$trows.="<tr><td colspan=2><input type=checkbox name=$field[name] value=1 ";
					if($record[$field[name]]) $trows.=" checked ";
					$trows.="> $field[display]</td></tr>";
				break;
				
				case 'textarea':
				break;
				
				//wide textarea (on 2 table columns)
				case 'widearea':
					$parts=explode(",",$field[fsize]);
					$r=$parts[0];
					$c=$parts[1];
				
					$trows.="<tr><td colspan=2>$field[display]:<br>
					<textarea name=\"$field[name]\" rows=$r cols=$c>".$record[$field[name]]."</textarea>
					</td></tr>";
				break;
				
				case 'date':
					$trows.="<tr><td>$field[display]:</td>
					<td>".date_chooser($field[name],$record[$field[name]])."</td></tr>";
				break;
				
				case 'date_static':
					$trows.="<tr><td>$field[display]:</td>
					<td width=$field[cwidth]>".date_format2($record[$field[name]])."</td></tr>";
				break;
				
				case 'multiselect':
					$trows.="<tr><td>$field[display]</td>
					<td width=$field[csize]><select name=".$field[name]."[] multiple size=$field[fsize]>";
					
					//explode values
					switch($field[valtype])
					{
						case 'string':
							// "|" separated string
							$vals=explode("|",$record[$field[name]]);
						break;
					}
					
										
					//get separation for the value->display of the option tag
					$parts=explode("|",$field[option]);
									
					foreach($field[inits] as $init)
					{
						if(@in_array($init[$parts[0]],$vals)) $selected='selected';
						else $selected='';
						$trows.="<option $selected value=\"".$init[$parts[0]]."\">".$init[$parts[1]]."</option>";
					}
					
					$trows.="</select></td>";
				break;
			}				
		}
		
		if($buttons)
		{
			$trows.="<tr><td colspan=2 align=center>";
		
			if($validate)
			{
				$trows.="<input type=hidden name=ok value=1>
				<input type=button class=button value='Save Data' onclick=\"javascript:validateForm(this.form);\">";
			}
			else
			{
				$trows.="<input type=submit name=ok value='Save Data' class=button> ";
			}			
			
			if($id)
			{	
				$trows.="<input type=hidden name=del value=0>
				<input type=button value=Delete onclick=\"javascript:confirmDelete(this.form);\" class=button>";
			}
		}	
		
		
		return $trows;
		
	} //end one_table
	
	//to add row
	function add()
	{
		global $DB;
		
		$q=" INSERT INTO $this->table (";
		
		//add fields
		foreach($this->fields as $field)
		{			
			$q.=$field[name].",";						
		}
		$q=substr($q,0,strlen($q)-1);		
		
		$q.=") VALUES (";
		
		foreach($this->fields as $field)
		{	
			switch($field[type])
			{
				case 'date_static':
				case 'text_static':
					//nothing
				break;
				
				case 'curdate':
					$q.=" CURDATE(),";
				break;
				
				case 'date':
					$q.=" \"".$_POST[$field[name].'year']."-".$_POST[$field[name].'month']."-".$_POST[$field[name].'day']."\", ";
				break;
				
				case 'multiselect':
					switch($field[valtype])
					{
						case 'string':
							//"|" separated string
							$val=@implode("|",$_POST[$field[name]]);
							
							$q.=" \"|$val|\",";
						break;
					}
				break;
				
				default:
					$q.="\"".$_POST[$field[name]]."\",";
				break;
			}
			
		}
		
		$q=substr($q,0,strlen($q)-1);
		
		$q.=")";
						
		
		$DB->q($q);
		
		alert("Record added");
		
		$lid=$DB->lid();
		return $lid;
	} //end add function
	
	
	//to edit a row
	function edit($fld,$id)
	{
		global $DB;
		
		$q="UPDATE $this->table SET ";
		
		foreach($this->fields as $field)
		{
			switch($field[type])
			{
				case 'date_static':
				case 'text_static':
					//nothing
				break;
				
				case 'curdate':
					$q.=" $field[name]=CURDATE(), ";
				break;
								
				case 'date':
					$q.=" $field[name]=\"".$_POST[$field[name].'year']."-".$_POST[$field[name].'month']."-".$_POST[$field[name].'day']."\", ";
				break;
				
				case 'pass':
					if(!empty($_POST[$field[name]]))
					{
						$q.=" $field[name]=\"".$_POST[$field[name]]."\", ";
					}
				break;
				
				case 'multiselect':
					switch($field[valtype])
					{
						case 'string':
							//"|" separated string
							$val=@implode("|",$_POST[$field[name]]);
							
							$q.=" $field[name]=\"|$val|\", ";
						break;
					}
				break;
				
				default:
					$q.=" $field[name]=\"".$_POST[$field[name]]."\", ";
				break;
			}
		}
		$q=substr($q,0,strlen($q)-2);		
		$q.="\n WHERE $fld=\"$id\"";		
		$DB->q($q);
		
		alert("Record saved");
	} //end edit function
	
	//to delete a record
	function delete($fld,$id)
	{
		global $DB;
		
		$q="DELETE FROM $this->table WHERE $fld=\"$id\"";
		$DB->q($q);
		
		alert("Record deleted");		
	} // end delete function
	
	
	//to select count
	function count($where_sql="")
	{
		global $DB;
		
		$q="SELECT COUNT(id) FROM $this->table $where_sql";
		$count=$DB->oq($q);
		
		return $count;
	}
}

?>